/// multipass_add(id, view_index, clear_color, clear_alpha, target)

// id - id of render pass.
// view_index - index of view which size will be used to create pass surface.
// clear_color - color used to clear pass surface before rendering objects.
// clear_alpha - alpha used to clear pass surface before rendering objects.
// target - id of object(s) which should be rendered by this pass (self, all are fine too).

// Add pass to multipass engine.
// Pass is a rendering phase which will perform rendering for special case
// completely handled by developer.
// Pass can be used for example to draw all objects to surface (or to screen)
// that accepts given pass.
// It's good to think that pass is used mostly to render some additional
// information of our scene that can be used by effects
// (for example to render normal map or light map that light effect will use).

var surface = -1;
if (argument1 >= 0) {
    surface = surface_create(view_wview[argument1], view_hview[argument1]);
}

var data = ds_map_create();
ds_map_add(data, "view", argument1);
ds_map_add(data, "surface", surface);
ds_map_add(data, "clear_color", argument2);
ds_map_add(data, "clear_alpha", argument3);
ds_map_add(data, "target", argument4);

ds_map_add_map(global.__multipass_map, argument0, data);

