/// multipass_render_pass(id)

// id - id of render pass.

// Render given pass.

if (global.__multipass_current != undefined) {
    return undefined;
}

if (ds_map_exists(global.__multipass_map, argument0)) {
    var data = ds_map_find_value(global.__multipass_map, argument0);
    if (data >= 0) {
        var view = ds_map_find_value(data, "view");
        if (view >= 0 && view != view_current) {
            return undefined;
        }
        
        var surface = ds_map_find_value(data, "surface");
        if (surface >= 0) {
            var matrix = matrix_get(matrix_view);
            
            surface_set_target(surface);
            matrix_set(matrix_view, matrix);

            var clear_color = ds_map_find_value(data, "clear_color");
            var clear_alpha = ds_map_find_value(data, "clear_alpha");
            draw_clear_alpha(clear_color, clear_alpha);
        }

        var target = ds_map_find_value(data, "target");
        global.__multipass_current = argument0;
        with (target) {
            event_perform(ev_draw, 0);
        }
        global.__multipass_current = undefined;
        
        if (surface >= 0) {
            surface_reset_target();
        }
    }
}

