// attributes used by GM to give us information about current vertex.
attribute vec3 in_Position;
attribute vec2 in_TextureCoord;

// variable shared with fragment shader with information about texture coordinate.
varying vec2 v_Texcoord;

void main()
{
    // prepare vertex position.
    vec4 pos = vec4(in_Position.xyz, 1.0);
    
    // send vertex texture coordinate to fragment shader.
    v_Texcoord = in_TextureCoord;
    
    // multiply vertex position by WVP matrix so we get screen position of world vertex.
    gl_Position = gm_Matrices[MATRIX_WORLD_VIEW_PROJECTION] * pos;
}

//######################_==_YOYO_SHADER_MARKER_==_######################@~
// texture used for dirt mask.
uniform sampler2D s_Mask;

// texture coordinate variable shared with vertex program.
varying vec2 v_Texcoord;

void main()
{
    // get current pixel color of dirt color texture.
    vec4 color = texture2D(gm_BaseTexture, v_Texcoord);

    // get current pixel color of dirt mask texture.
    vec4 mask = texture2D(s_Mask, v_Texcoord);
    
    // mix dirt color with mask so dirt will be visible only when mask is there too.
    gl_FragColor = vec4(color.xyz, mask.w * color.w);
}

